
Title    Inbuild Encryption 1.0
code     segment
org      100h
assume   cs:code,ds:code
Jumps

CHRiSTOPH:

db 15d dup (90h)        ; The important line to crypt with Inbuild Encryption.

Mov Ah, 09
Mov Dx, offset Begin    ; Display a pretty ascii logo. ;)
Int 21h

Mov Ch, 0               ; Clear CH because we add a word next time.
Mov Cl, Ds:[80h]        ; Get size of the syntax we entered.
Cmp Cl, 0               ; If zero we didn't enter anything.
Je Error1               ; If so, jump and display an error message.

Mov Di, 81h              
Add Di, Cx              ; Count + 81h = End of entered syntax.
Xor Ax, Ax              ; Write a 00.
Stosb                   ; AL=DS:DI

Cmp CS:word ptr [82h],'?/'   ; If the syntax was '/?'
Je Para
Cmp CS:word ptr [82h],'?-'   ; or '-?' display information.
Je Para

Mov Bh, 00                   ;
Mov bl, Ds:[80h]             ; Calculate offset to end - 2
Add bl, 7Fh                  ;

Cmp CS:word ptr [BX],'l/'    ;
Je Low_Mode                  ; Did someone specify '/L' or '/l', then jump.
Cmp CS:word ptr [BX],'L/'    ;
Je Low_Mode

Back:

Mov Ah, 3Dh
Mov Dx, 82h                     ; DS:DX points to filename we entered.
Int 21h                         ; Open the file we entered.
Jc Error2                       ; Jump if carry flag set, error eccoured.
Mov [Handle], Ax                ; Returns AX=Handle, store in DS:offset Handle

mov ax,4200h
cwd                             ; Clear direction.
Xor Cx, Cx                      ; CX=High bytes of moving
Mov Dx, Decr_Start - Decryptor  ; DX=Low bytes of moving
Mov Bx, [Handle]                ; BX=Handle
int 21h                         ; Move file pointer after decryptor.

Mov Ah, 43h
Mov Al, 1                       ; AL=Mode
Mov Dx, 82h                     ; DX=Filename
Xor Cx, Cx                      ; CX=Attribute
Int 21h                         ; Clear attributes.

Mov Ah, 3Fh
Mov Dx, offset Decr_Start       ; DX=Where to place bytes.
Mov Bx, [Handle]                ; BX=Handle
Mov Cx, -1                      ; CX=Ammount of bytes
Int 21h                         ; Get code from file to encrypt.

Mov [FileSize], Ax              ; Returns AX=Filepointer - EOF

; Encryptor

Mov Cx, Ax                      ; CX=Ammount of bytes.
Mov Bx, offset Decr_Start       ; BX=Where to encrypt.
Mov Dx, 100h                    ; DX=Only used for normal encryption.
Add Dx, Decr_Start - Decryptor  ; Generate the the BX offset in COM files.

Encrypt:
Add CS:byte ptr [BX],Dl         ; Encrypt with ADD. 
Ror CS:byte ptr [BX],Cl         ; Encrypt with ROR.
Inc Dx
Inc Bx
Loop Encrypt

Mov Ax, 4200h
Cwd                             ; Clear direction
Xor Cx, Cx                      ; CX=Higher word to move to
Xor Dx, Dx                      ; DX=Lower word to move to
Mov Bx, [Handle]                ; BX=Handle
Int 21h                         ; Move file pointer to beginning of file.

; ** Lameness
Mov Ah, 3Eh
Mov Bx, [Handle]                
Int 21h                         
Mov Ah, 43h
Mov Al, 1
Mov Dx, 82h
Xor Cx, Cx
Int 21h                         
Mov Ah, 3Dh
Mov Dx, offset 82h
Int 21h
Mov [Handle], Ax
; Lameness **

Mov Ax, [FileSize]              ; --
Mov Bx, offset Bytes +1         ; ---> Calculate ammount of bytes in decr.
Mov CS:word ptr [BX], Ax        ; --

Mov Ax, 100h                    ; --
Add Ax, Decr_Start - Decryptor  ; --> Calculate offset for decryptor
Mov Bx, offset Where +1         ; --> so it decrypts from the right offset.
Mov CS:word ptr [BX], Ax        ; --

Mov Dx, offset Decryptor        ; DS:DX=From where to write.
Mov Cx, Decr_Start - Decryptor
Mov Ax, [FileSize]
Add Cx, Ax                      ; CX=Ammount of bytes to write.
Mov Ah, 40h
Mov Bx, [Handle]                ; BX=Handle
Int 21h                         ; Write the decryptor/code to file.

Mov Ah, 3Eh
Mov Bx, [Handle]                ; BX=Handle
Int 21h                         ; Close file.

Mov Ch, 0
Mov Cl, Ds:[80h]
Mov Di, 81h
Add Di, Cx
Cmp CS: byte ptr [DI-3], 00h    ; If Syntax-3 = Zero, then '/L' was entered.
Jne OK_Norm

Mov CS:byte ptr [DI-3], '$'

Mov Ah,9
Mov Dx,offset Low_Msg
Int 21h

OK_Norm: Mov CS:byte ptr [DI], '$'

; Print 'Encrypting file "..."'
Mov Ah,9
Mov Dx,offset Encrypt_Msg
Int 21h                         ; Ok, a little bit to late, but...  ;)
                                
Mov Ah,9
Mov Dx,82h
Int 21h

Mov Ah,9
Mov Dx,offset Points
Int 21h

; Print 'Writing file "..."'

Mov Ah,9
Mov Dx,offset Write_Msg
Int 21h                         ; Didn't we already write??  ;)
                                
Mov Ah,9
Mov Dx,offset Points
Int 21h

Mov Ah,9
Mov Dx,offset Success_Msg
Int 21h                         ; End message.

INT 20h

; Low Mode, if '/L' was spefified.

Low_Mode:

Dec Bx
Mov CS:byte ptr [BX], 00

Mov Ah,2Ch
Int 21h                      ; Get time for random numbers.

Mov Bx, offset Encrypt
Mov CS:byte ptr [BX], 80h    ; Patch encryption.
Inc Bx
Mov CS:byte ptr [BX], 07h    ; Patch encryption.
Inc Bx
Mov CS:byte ptr [BX], Dl     ; DL=Random number.

Inc Bx
Mov CS:byte ptr [BX], 0C0h   ; Patch encryption.
Inc Bx
Mov CS:byte ptr [BX], 0Fh    ; Patch encryption.
Inc Bx
Mov CS:byte ptr [BX], Dh     ; DH=Random number.

Mov Bx, offset Decrypt       
Mov CS:byte ptr [BX], 0C0h   ; Patch decryption.
Inc Bx
Mov CS:byte ptr [BX], 07h    ; Patch decryption.
Inc Bx
Mov CS:byte ptr [BX], Dh     ; DH=Random number.

Inc Bx
Mov CS:byte ptr [BX], 80h    ; Patch decryption.
Inc Bx
Mov CS:byte ptr [BX], 2Fh    ; Patch decryption.
Inc Bx
Mov CS:byte ptr [BX], Dl     ; DL=Random number.

Jmp Back

Error1:
Mov Ah,09
Mov Dx,offset Error1_Msg
Int 21h
Int 20h

Error2:
Mov Ah,09
Mov Dx,offset Error2_Msg
Int 21h
Int 20h

Para:
Mov Ah,09
Mov Dx,offset Para_Msg
Int 21h
Int 20h

Error1_Msg  db 0Dh,0Ah,'  SYNTAX: INBUILD [COM_FILE]',0Dh,0Ah,'$'
Error2_Msg  db 0Dh,0Ah,'   Could not find the file.',0Dh,0Ah,'$'
Low_Msg     db 0Dh,0Ah,'Using low encryption rate for afterwards compression.',0Dh,0Ah,'$'
Encrypt_Msg db 0Dh,0Ah,'Encrypting file ','$'
Points      db         '...','$'
Write_Msg   db 0Dh,0Ah,'Writing file to disk','$'
Success_Msg db 0Dh,0Ah,'File successfully encrypted.',0Dh,0Ah,'$'
Para_Msg    db 0Dh,0Ah,'Project : Selfencryption for COM files'
            db 0Dh,0Ah,'Method  : Using ADD/ROR, variable to filesize'
            db 0Dh,0Ah,'Date    : 27.11.98'
            db 0Dh,0Ah,'Type    : DOS file Security'
            db 0Dh,0Ah,'Switch  : /L will use low encryption mode'
            db 0Dh,0Ah,'Notes   : The first 15 bytes must not contain executable code',0Dh,0Ah,'$'
     

Begin       db 0Dh,0Ah,''
            db 0Dh,0Ah,'   Inbuild Encryption 1.0    '
            db 0Dh,0Ah,'  Coded by Christoph Gabler  '
            db 0Dh,0Ah,'',0Dh,0Ah,'$'


Handle      dw  00
FileSize    dw  00

; Decryptor

Decryptor:
Bytes: Mov Cx,0FFFFh
Where: Mov Bx,0FFFFh
Decrypt:
Rol CS:byte ptr [BX],Cl
Sub CS:byte ptr [BX],Bl
Inc Bx
Loop Decrypt
Decr_Start:

code ends
end CHRiSTOPH
